# PLL Constraints
#################
create_clock -period 40.0000 MAIN_CLK
#create_clock -period 50.0000 MAIN_CLK      
create_clock -period 100.0000 jtag_inst1_TCK
create_clock -period 16.0000 LVDS_TXCLK
create_clock -period 16.0000 LVDS_RXCLK

# False Path
#################
set_clock_groups -exclusive  -group {MAIN_CLK} -group {jtag_inst1_TCK}
set_clock_groups -exclusive  -group {MAIN_CLK} -group {LVDS_TXCLK}
set_clock_groups -exclusive  -group {MAIN_CLK} -group {LVDS_RXCLK}

#SPI Constraints
#################
set_output_delay -clock MAIN_CLK -max -4.700 [get_ports {SD_SCLK_OUT}]
set_output_delay -clock MAIN_CLK -min -2.571 [get_ports {SD_SCLK_OUT}]
set_output_delay -clock MAIN_CLK -max -4.700 [get_ports {SD_CS_N_OUT}]
set_output_delay -clock MAIN_CLK -min -2.571 [get_ports {SD_CS_N_OUT}]
#set_input_delay -clock MAIN_CLK -max 6.168 [get_ports {SD_MOSI_IN}]
#set_input_delay -clock MAIN_CLK -min 3.084 [get_ports {SD_MOSI_IN}]
set_output_delay -clock MAIN_CLK -max -4.700 [get_ports {SD_MOSI_OUT}]
set_output_delay -clock MAIN_CLK -min -2.571 [get_ports {SD_MOSI_OUT}]
#set_output_delay -clock MAIN_CLK -max -4.707 [get_ports {SD_MOSI_OE}]
#set_output_delay -clock MAIN_CLK -min -2.567 [get_ports {SD_MOSI_OE}]
set_input_delay -clock MAIN_CLK -max 6.168 [get_ports {SD_MISO_IN}]
set_input_delay -clock MAIN_CLK -min 3.084 [get_ports {SD_MISO_IN}]
#set_output_delay -clock MAIN_CLK -max -4.700 [get_ports {SD_MISO_OUT}]
#set_output_delay -clock MAIN_CLK -min -2.571 [get_ports {SD_MISO_OUT}]
#set_output_delay -clock MAIN_CLK -max -4.707 [get_ports {SD_MISO_OE}]
#set_output_delay -clock MAIN_CLK -min -2.567 [get_ports {SD_MISO_OE}]

set_output_delay -clock MAIN_CLK -max -4.700 [get_ports {ADDA_FLASH_SCK_OUT}]
set_output_delay -clock MAIN_CLK -min -2.571 [get_ports {ADDA_FLASH_SCK_OUT}]
set_output_delay -clock MAIN_CLK -max -4.700 [get_ports {FLASH_CS_N_OUT}]
set_output_delay -clock MAIN_CLK -min -2.571 [get_ports {FLASH_CS_N_OUT}]
set_output_delay -clock MAIN_CLK -max -4.700 [get_ports {ADC_CS_N_OUT}]
set_output_delay -clock MAIN_CLK -min -2.571 [get_ports {ADC_CS_N_OUT}]
set_output_delay -clock MAIN_CLK -max -4.700 [get_ports {DAC_CS_N_OUT}]
set_output_delay -clock MAIN_CLK -min -2.571 [get_ports {DAC_CS_N_OUT}]
set_input_delay -clock MAIN_CLK -max 6.168 [get_ports {ADDA_FLASH_MOSI_IN}]
set_input_delay -clock MAIN_CLK -min 3.084 [get_ports {ADDA_FLASH_MOSI_IN}]
set_output_delay -clock MAIN_CLK -max -4.700 [get_ports {ADDA_FLASH_MOSI_OUT}]
set_output_delay -clock MAIN_CLK -min -2.571 [get_ports {ADDA_FLASH_MOSI_OUT}]
#set_output_delay -clock MAIN_CLK -max -4.707 [get_ports {ADDA_FLASH_MOSI_OE}]
#set_output_delay -clock MAIN_CLK -min -2.567 [get_ports {ADDA_FLASH_MOSI_OE}]
set_input_delay -clock MAIN_CLK -max 6.168 [get_ports {ADDA_FLASH_MISO_IN}]
set_input_delay -clock MAIN_CLK -min 3.084 [get_ports {ADDA_FLASH_MISO_IN}]
set_output_delay -clock MAIN_CLK -max -4.700 [get_ports {ADDA_FLASH_MISO_OUT}]
set_output_delay -clock MAIN_CLK -min -2.571 [get_ports {ADDA_FLASH_MISO_OUT}]
#set_output_delay -clock MAIN_CLK -max -4.707 [get_ports {ADDA_FLASH_MISO_OE}]
#set_output_delay -clock MAIN_CLK -min -2.567 [get_ports {ADDA_FLASH_MISO_OE}]

#set_input_delay -clock MAIN_CLK -max 6.168 [get_ports {GPIO7_CE1_PMM_IO9_IN}]
#set_input_delay -clock MAIN_CLK -min 3.084 [get_ports {GPIO7_CE1_PMM_IO9_IN}]
set_output_delay -clock MAIN_CLK -max -4.700 [get_ports {GPIO7_CE1_PMM_IO9_OUT}]
set_output_delay -clock MAIN_CLK -min -2.571 [get_ports {GPIO7_CE1_PMM_IO9_OUT}]
#set_output_delay -clock MAIN_CLK -max -4.707 [get_ports {GPIO7_CE1_PMM_IO9_OE}]
#set_output_delay -clock MAIN_CLK -min -2.567 [get_ports {GPIO7_CE1_PMM_IO9_OE}]

#set_input_delay -clock MAIN_CLK -max 6.168 [get_ports {GPIO8_CE0_SS_PMM_IO10_IN}]
#set_input_delay -clock MAIN_CLK -min 3.084 [get_ports {GPIO8_CE0_SS_PMM_IO10_IN}]
set_output_delay -clock MAIN_CLK -max -4.700 [get_ports {GPIO8_CE0_SS_PMM_IO10_OUT}]
set_output_delay -clock MAIN_CLK -min -2.571 [get_ports {GPIO8_CE0_SS_PMM_IO10_OUT}]
#set_output_delay -clock MAIN_CLK -max -4.707 [get_ports {GPIO8_CE0_SS_PMM_IO10_OE}]
#set_output_delay -clock MAIN_CLK -min -2.567 [get_ports {GPIO8_CE0_SS_PMM_IO10_OE}]

set_input_delay -clock MAIN_CLK -max 6.168 [get_ports {GPIO9_MISO_IO12_IN}]
set_input_delay -clock MAIN_CLK -min 3.084 [get_ports {GPIO9_MISO_IO12_IN}]
#set_output_delay -clock MAIN_CLK -max -4.700 [get_ports {GPIO9_MISO_IO12_OUT}]
#set_output_delay -clock MAIN_CLK -min -2.571 [get_ports {GPIO9_MISO_IO12_OUT}]
#set_output_delay -clock MAIN_CLK -max -4.707 [get_ports {GPIO9_MISO_IO12_OE}]
#set_output_delay -clock MAIN_CLK -min -2.567 [get_ports {GPIO9_MISO_IO12_OE}]

#set_input_delay -clock MAIN_CLK -max 6.168 [get_ports {GPIO10_MOSI_PWM_IO11_IN}]
#set_input_delay -clock MAIN_CLK -min 3.084 [get_ports {GPIO10_MOSI_PWM_IO11_IN}]
set_output_delay -clock MAIN_CLK -max -4.700 [get_ports {GPIO10_MOSI_PWM_IO11_OUT}]
set_output_delay -clock MAIN_CLK -min -2.571 [get_ports {GPIO10_MOSI_PWM_IO11_OUT}]
#set_output_delay -clock MAIN_CLK -max -4.707 [get_ports {GPIO10_MOSI_PWM_IO11_OE}]
#set_output_delay -clock MAIN_CLK -min -2.567 [get_ports {GPIO10_MOSI_PWM_IO11_OE}]

#set_input_delay -clock MAIN_CLK -max 6.168 [get_ports {GPIO11_SCLK_SCK_IO13_IN}]
#set_input_delay -clock MAIN_CLK -min 3.084 [get_ports {GPIO11_SCLK_SCK_IO13_IN}]
set_output_delay -clock MAIN_CLK -max -4.700 [get_ports {GPIO11_SCLK_SCK_IO13_OUT}]
set_output_delay -clock MAIN_CLK -min -2.571 [get_ports {GPIO11_SCLK_SCK_IO13_OUT}]
#set_output_delay -clock MAIN_CLK -max -4.707 [get_ports {GPIO11_SCLK_SCK_IO13_OE}]
#set_output_delay -clock MAIN_CLK -min -2.567 [get_ports {GPIO11_SCLK_SCK_IO13_OE}]

# JTAG Constraints
####################
set_output_delay -clock jtag_inst1_TCK -max 0.111 [get_ports {jtag_inst1_TDO}]
set_output_delay -clock jtag_inst1_TCK -min 0.053 [get_ports {jtag_inst1_TDO}]
set_input_delay -clock_fall -clock jtag_inst1_TCK -max 0.267 [get_ports {jtag_inst1_CAPTURE}]
set_input_delay -clock_fall -clock jtag_inst1_TCK -min 0.134 [get_ports {jtag_inst1_CAPTURE}]
set_input_delay -clock_fall -clock jtag_inst1_TCK -max 0.231 [get_ports {jtag_inst1_SEL}]
set_input_delay -clock_fall -clock jtag_inst1_TCK -min 0.116 [get_ports {jtag_inst1_SEL}]
set_input_delay -clock_fall -clock jtag_inst1_TCK -max 0.321 [get_ports {jtag_inst1_SHIFT}]
set_input_delay -clock_fall -clock jtag_inst1_TCK -min 0.161 [get_ports {jtag_inst1_SHIFT}]
